/*	
 *	clipm68.c
 *
 *	P/ECE M6800 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Feb 01 06:23:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"
#include "clipm68i.h"	/*M6800G~[^p}N*/

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	IyR[h}bv
 */
const M6800OP m6800_op_table[256/*opcode*/] = {
#include "m6800/table.h" /* [m6801.xls]Table */
};

/*
 *	CXgNVe[u
 */
#undef M6800FN_
#define M6800FN_(OP, FN)	OP "\0"
const char m6800_op_name_table[] = {
	"\0" /* ItZbg0̓k */
#include "m6800/list.h" /* [m6801.xls]List */
};
#undef M6800FN_

/****************************************************************************
 *
 ****************************************************************************/

void
m6800_reset(M6800* m6800, M6800READPROC* read, M6800WRITEPROC* write)
{
	memset(m6800, 0, sizeof(M6800));
	m6800->read  = read  ? read  : m6800_internal_read;
	m6800->write = write ? write : m6800_internal_write;

	CC = 0xd0;		/* CC[7] Unused    = 1 Œ */
				/* CC[6] Unused    = 1 Œ */
				/* CC[5] HalfCarry = 0 */
				/* CC[4] Interrut  = 1 Zbg㊄荞݋֎~ */
				/* CC[3] Negative  = 0 */
				/* CC[2] Zero      = 0 */
				/* CC[1] Overflow  = 0 */
				/* CC[0] Carry     = 0 */
	PC = READW(M6800_RESET_VECTOR);
}

void
m6800_nmi(M6800* m6800)
{
	m6800_int(m6800, M6800_NMI_VECTOR);
}

void m6800_irq(M6800* m6800) { PENDING |= M6800_IRQ_PENDING; m6800_check_pending(m6800); }
void m6800_icf(M6800* m6800) { PENDING |= M6800_ICF_PENDING; m6800_check_pending(m6800); }
void m6800_ocf(M6800* m6800) { PENDING |= M6800_OCF_PENDING; m6800_check_pending(m6800); }
void m6800_tof(M6800* m6800) { PENDING |= M6800_TOF_PENDING; m6800_check_pending(m6800); }
void m6800_sci(M6800* m6800) { PENDING |= M6800_SCI_PENDING; m6800_check_pending(m6800); }

void
m6800_dump(M6800* m6800)
{
#define INDENT	40
	TRACE("%*s", INDENT, "");
	TRACE("CC:%c%c%c%c%c%c%c%c A:%02x B:%02x X:%04x S:%04x PC:%04x\n",
		CC & (1 << 7) ? '1' : '-',
		CC & (1 << 6) ? '1' : '-',
		CC & (1 << 5) ? 'H' : '-',
		CC & (1 << 4) ? 'I' : '-',
		CC & (1 << 3) ? 'N' : '-',
		CC & (1 << 2) ? 'Z' : '-',
		CC & (1 << 1) ? 'V' : '-',
		CC & (1 << 0) ? 'C' : '-',
		A, B, X, S, PC);
#undef INDENT
}

/****************************************************************************
 *
 ****************************************************************************/

#ifdef PIECE

asm("
	.code
	.global m6800_run2
m6800_run2:
	pushn %r0
	ld.w %r0, %sp		; X^bNޔ
	xld.w %r10, 0x1000	; 0x0e00`0x1000ɃX^bNؑ
	ld.w %sp, %r10
	xcall m6800_run
	ld.w %sp, %r0		; X^bN
	popn %r0
	ret
");

#endif /*PIECE*/

/****************************************************************************
 *
 ****************************************************************************/

