/*	
 *	clipwsg.c
 *
 *	P/ECE Namco WSG Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Feb 15 04:29:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

void
wsg_reset(WSG* wsg, int clock, const void* wavetable/*[0x100]*/)
{
	int i;
	const char* src;
	      char* dst;

	memset(wsg, 0, sizeof(WSG));

	/* NbNisDDAZbgAbvB */
	wsg->clock_progress.u = clock / SPEAKER_FREQUENCY; /* ̕ω */
	wsg->clock_progress.n = clock % SPEAKER_FREQUENCY; /* [̑ */
	wsg->clock_progress.d =        -SPEAKER_FREQUENCY; /* [ */

	/* g`e[u쐬B */
	src = (const char*)wavetable;
	dst = &wsg->wavetable[0][0];
	for(i = 0; i < 0x100; i++) {
		*dst++ = (*src++ & 0xf) - 8; /* 0`15 => -8`+7 */
	}

	/* channel.waveLɂ邽߁ASWX^𖾎Iɏ܂B */
	for(i = 0; i < 0x40; i++) {
		wsg_write(wsg, i, 0); /* ǂtypeł\܂ */
	}
}

void
wsg_write_mappy(WSG* wsg, int addr, unsigned char data)
{
	int i_channel;
	WSGCHANNEL* channel;
	unsigned char* reg;

	if(addr < 0 || addr > 0x3f) DIE();

	/* WX^li[B */
	reg = wsg->reg;
	reg[addr] = data;

	/* `lݒ̏B */
	i_channel = addr >> 3;			/* `lԍ (0`7) */
	channel = &wsg->channel[i_channel];	/* `l */
	reg += i_channel << 3;			/* ̃`l̃WX^x[X */
	addr &= 7;				/* WX^x[X̃ItZbg (0`7) */

	/* `lݒB */
	switch(addr) {
	case 6:	/* ?wwwffff (f:Frequency[19:16], w=WavetableSelect) */
		channel->wave = wsg->wavetable[(reg[6] >> 4) & 7];
		/* fall thru */
	case 5:	/* ffffffff (f:Frequency[15: 8]) */
	case 4:	/* ffffffff (f:Frequency[ 7: 0]) */
		channel->frequency = ((reg[6] & 0xf) << 8 | reg[5]) << 8 | reg[4];
		break;
	case 3:	/* ????vvvv (v:Volume) */
		channel->volume = reg[3] & 0xf;
		break;
	}
}

